<?php
header("Content-Type: text/html; charset=UTF-8");
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>Chapter 4 : Data Formats - Charset Explorer</title>
<style type="text/css">
    body {font-family: Verdana, Arial, Sans-serif;}
	h1 {text-align: center;}
	.deleteButton {background-color: transparent; color: #990000; font-weight: bold; font-size: larger; border-style: hidden; margin-left: 5px;}
	#responseOutput {border-top-style: dashed; border-top-width: 2px;}
</style>
<link rel="stylesheet" href="global.css" type="text/css" media="screen" />
<script type="text/javascript">
function escapeValue(value)
{
 var escapedVal = (encodeURIComponent) ? encodeURIComponent(value) : escape(value);
 return escapedVal.replace(/\%20/g,'+');
}

function createXHR()
{
   try { return new XMLHttpRequest(); } catch(e) {}
   try { return new ActiveXObject("Msxml2.XMLHTTP.6.0"); } catch (e) {}
   try { return new ActiveXObject("Msxml2.XMLHTTP.3.0"); } catch (e) {}
   try { return new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) {}
   try { return new ActiveXObject("Microsoft.XMLHTTP"); } catch (e) {}

   return null;
}


function sendRequest(form)
{
	var url = "http://ajaxref.com/ch4/charsetexplorerresponse.php";
    var responseOutput = document.getElementById("responseOutput");
    responseOutput.innerHTML = "";
    
	var xhr = createXHR();
    if (xhr)
    {
	 var requestCharset = form.requestCharset.options[form.requestCharset.selectedIndex].value;
	 var responseCharset = form.responseCharset.options[form.responseCharset.selectedIndex].value;
	 var payloadString = form.payloadString.options[form.payloadString.selectedIndex].text;
	 if (payloadString == "Custom")
	 	payloadString = form.customText.value;
		
	 var payload = "payloadString=" + escapeValue(payloadString);
	 payload += "&responseCharset=" + escapeValue(responseCharset);
	 payload += "&translate=" + form.translate.checked;
	 
	 xhr.open("GET", url + "?" + payload, true);
	 xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=" + requestCharset);
	 xhr.onreadystatechange = function(){handleResponse(xhr, payload);};
     xhr.send(null);
    } 
	
}

function handleResponse(xhr, payload)
{
    if (xhr.readyState == 4)
	{
     if (xhr.status == 200)
	  {
	    var characterEncoding = (document.characterSet) ? (document.characterSet): document.charset;
		 
		var responseOutput = document.getElementById("responseOutput");
		var responseHeaders = xhr.getAllResponseHeaders().replace(/<([^>]*)>/g, "&lt;$1&gt;").replace(/\n/g, "<br/>");
	    var responseString = xhr.responseText.replace(/<([^>]*)>/g, "&lt;$1&gt;").replace(/\n/g, "<br/>");
		
		responseOutput.innerHTML = '<h3>Request</h3><strong>Payload</strong><div class="data">' + payload + '</div>';
		responseOutput.innerHTML += '<h3>Response</h3><strong>Headers</strong><div class="data">' + responseHeaders + '</div>';
		responseOutput.innerHTML += '<strong>Payload</strong><div class="data">' + responseString + '</div>'; 
		responseOutput.style.display = "";
      }
	 else 
	  {
       var responseOutput = document.getElementById("responseOutput");
	   var converted = xhr.getAllResponseHeaders();
	   if (converted)
	   {
		converted = converted.replace(/<([^>]*)>/g, "&lt;$1&gt;");
	    converted = converted.replace(/\n/g, "<br/>");
	   }
		
	   responseOutput.innerHTML = '<h3>Response</h3><strong>Status</strong><div class="data"> ' + xhr.status + " " + xhr.statusText + '</div>';
	   responseOutput.innerHTML += '<strong>Headers</strong><div class="data">' + converted + '</div>';
	   responseOutput.innerHTML += '<strong>Payload</strong><div class="data">' + xhr.responseText.replace(/<([^>]*)>/g, "&lt;$1&gt;").replace(/\n/g, "<br/>") + '</div>';
	   responseOutput.style.display = "";        
      }
	}
}

function updateCustom(form)
{
	var payloadString = form.payloadString.options[form.payloadString.selectedIndex].text;
	var customText = document.getElementById("customText");
	if (payloadString == "Custom")
		customText.style.display = "";
	else
		customText.style.display = "none";	
}


window.onload = function () 
{ 
 document.requestForm.requestButton.onclick = function () { sendRequest(this.form); };
 document.requestForm.payloadString.onchange = function(){updateCustom(this.form);};
}; 

</script>
</head>
<body>
<h1>Ajax Charset Explorer</h1>
<form action="#" name="requestForm">

<table>
<tr><td>Request Charset:</td>
<td colspan="3">
	<select name="requestCharset">
	 <option value="UTF-8">Unicode: UTF-8</option>
 	 <option value="US-ASCII">Western: US-ASCII</option>
	 <option value="ISO-8859-1">Western: ISO-8859-1</option>
	 <option value="ISO-8859-6">Arabic: ISO-8859-6</option>
	 <option value="Shift_JIS">Japanese: Shift_JIS</option>
	 <option value="ISO-8859-7">Greek: ISO-8859-7</option>
	</select>
</td></tr>
<tr><td>Response Charset:</td>
<td colspan="3">
	<select name="responseCharset">
	 <option value="UTF-8">Unicode: UTF-8</option>
 	 <option value="US-ASCII">Western: US-ASCII</option>
	 <option value="ISO-8859-1">Western: ISO-8859-1</option>
	 <option value="ISO-8859-6">Arabic: ISO-8859-6</option>
	 <option value="Shift_JIS">Japanese: Shift_JIS</option>
	 <option value="ISO-8859-7">Greek: ISO-8859-7</option>
	</select>&nbsp;
Translate on Server:&nbsp;<input type="checkbox" name="translate" value="true" checked="checked" /></td></tr>
<tr><td>Payload String:</td>
<td>
	<select name="payloadString">
	 	<option title="Arabic"">لماذا لا يتكلمون اللّغة العربية فحسب؟</option>
		<option title="Chinese">他们为什么不说中文（中国）？</option>
		<option title="English">Why can't they just speak English?</option>
		<option title="French">Pourquoi, tout simplement, ne parlent-ils pas français?</option>
		<option title="German">Warum sprechen sie nicht einfach Deutsch?</option>
		<option title="Greek">Μα γιατί δεν μπορούν να μιλήσουν Ελληνικά;</option>
		<option title="Hindi">यह लोग हिन्दी क्यों नहीं बोल सकते हैं ?</option>
		<option title="Italian">Perché non possono semplicemente parlare italiano?</option>
		<option title="Japanese">なぜ、みんな日本語を話してくれないのか</option>
		<option title="Korean">세계의 모든 사람들이 한국어를 이해한다면 얼마나 좋을까?</option>
		<option title="Russian">Почему же они не говорят по-русски?</option>
		<option title="Spanish">¿Por qué no pueden simplemente hablar en Español?</option>
		<option title="Custom">Custom</option>
	</select>
</td>
<td colspan="2"><input type="text" size="40" style="display:none" id="customText" name="customText" /></td>
</tr>
</table>

<br /><br /><br />
  <input type="button" name="requestButton" value="Send Request" />
</form>
<br />

<div id="responseOutput" class="results" style="display:none;">&nbsp;</div>

</body>
</html>

